VERSION 2.00
Begin Form List
   Caption         =   "List"
   ClientHeight    =   5820
   ClientLeft      =   3015
   ClientTop       =   2400
   ClientWidth     =   7365
   Height          =   6510
   Left            =   2955
   LinkTopic       =   "Form1"
   ScaleHeight     =   5820
   ScaleWidth      =   7365
   Top             =   1770
   Width           =   7485
   Begin TextBox eMessage
      Height          =   5775
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   0
      Width           =   7335
   End
   Begin Menu mList
      Caption         =   "List"
   End
   Begin Menu mExit
      Caption         =   "Exit"
   End
End

Option Explicit

Sub Display (Buffer As String)
eMessage.Text = eMessage.Text & Buffer & Chr$(13) & Chr$(10)
End Sub

Function Extract (LineNbr As Integer, Buffer As String) As Integer
Dim I As Integer
Dim Code As Integer
Dim X As String
Dim Temp As String * 120
' show entire line
Temp = Space$(120)
Code = fceExtract(Buffer, LineNbr, 0, Temp, 120)
If Code <= 0 Then
  Extract = 0
  Exit Function
Else
  '''MsgBox Left$(Temp, Code)
  Call Display(Left$(Temp, Code))
End If
' display each field
For I = 1 To 12
  Temp = Space$(120)
  Code = fceExtract(Buffer, LineNbr, I, Temp, 120)
  If Code = 0 Then
    Exit For
  End If
  X = "Line " & Str$(LineNbr) & ", Field " & Str$(I) & " = [" & Left$(Temp, Code) & "]"
  Call Display(X)
Next I
Extract = 1
End Function

Sub Form_Load ()
Dim Code As Integer
Dim Version As Integer
Dim S1, S2, S3 As String
Dim Temp As String * 120
' attach FCE
Code = fceAttach(1, FCE_KEY_CODE)
' get FCE version number
Version = fceGetInteger(0, FCE_GET_VERSION)
S1 = "FTP Client Engine Version "
S2 = Hex$(Version)
S3 = Mid$(S2, 1, 1) + "." + Mid$(S2, 2, 1) + "." + Mid$(S2, 3, 1)
Call Display(S1 + S3)
' get registration string
Code = fceGetString(0, FCE_GET_REGISTRATION, Temp, 80&)
Call Display(Left$(Temp, Code))
End Sub

Sub mExit_Click ()
Dim Code As Integer
Code = fceRelease()
End
End Sub

Sub mList_Click ()
Dim Code As Integer
Dim Server As String
Dim User As String
Dim Pass As String
Dim LineNbr As Integer
Dim Temp As String * 120
Const BUFFER_SIZE = 3000
Dim Buffer As String * BUFFER_SIZE

Server = "10.0.0.1"
User = "mike"
Pass = "mike"

Call Display("Server = " + Server)
Call Display("User = " + User)
Call Display("Pass = " + Pass)

Code = fceSetString(0, FCE_SET_LOG_FILE, "LIST16.LOG")

' [uncomment to use "Passive Mode"]
'''Code = fceSetInteger(0, FCE_SET_PASSIVE, 1)

' connect to server
Code = fceConnect(0, Server, User, Pass)
If Code < 0 Then
  Call ShowError(Code)
  Exit Sub
End If
DoEvents
Call Display("Connected to " + Server)
Temp = Space$(120)
Code = fceGetServerDir(0, Temp, 120)
Call Display("ServerDir = " + Left$(Temp, Code))
' ask for full list
Buffer = Space$(BUFFER_SIZE)
Code = fceGetList(0, FCE_FULL_LIST, Buffer, BUFFER_SIZE)
If Code <= 0 Then
  Call ShowError(Code)
  Exit Sub
End If
' get each  line
For LineNbr = 1 To 1000
  Code = Extract(LineNbr, Buffer)
  If Code = 0 Then
    Exit For
  End If
Next LineNbr
' close
DoEvents
Code = fceClose(0)
End Sub

Sub ShowError (ByVal Code As Long)
Dim Length As Integer
Dim Temp As String * 128
Length = fceErrorText(0, Code, Temp, 128)
Call Display(Left$(Temp, Length))
End Sub

