VERSION 4.00
Begin VB.Form List
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   Caption         =   "List"
   ClientHeight    =   5820
   ClientLeft      =   3015
   ClientTop       =   2400
   ClientWidth     =   7365
   BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851}
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Height          =   6510
   Left            =   2955
   LinkTopic       =   "Form1"
   ScaleHeight     =   5820
   ScaleWidth      =   7365
   Top             =   1770
   Width           =   7485
   Begin VB.TextBox eMessage
      Appearance      =   0  'Flat
      Height          =   5775
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   0
      Width           =   7335
   End
   Begin VB.Menu mList
      Caption         =   "List"
   End
   Begin VB.Menu mExit
      Caption         =   "Exit"
   End
End
Attribute VB_Name = "List"
Attribute VB_Creatable = False
Attribute VB_Exposed = False

Option Explicit

Private Sub Display(Buffer As String)
eMessage.Text = eMessage.Text & Buffer & Chr$(13) & Chr$(10)
End Sub

Private Function Extract(LineNbr As Integer, Buffer As String) As Integer
Dim I As Integer
Dim Code As Long
Dim X As String
Dim Temp As String * 120
' show entire line
Temp = Space$(120)
Code = fceExtract(Buffer, LineNbr, 0, Temp, 120)
If Code <= 0 Then
  Extract = 0
  Exit Function
Else
  '''MsgBox Left$(Temp, Code)
  Call Display(Left$(Temp, Code))
End If
' display each field
For I = 1 To 12
  Temp = Space$(120)
  Code = fceExtract(Buffer, LineNbr, I, Temp, 120)
  If Code = 0 Then
    Exit For
  End If
  X = "Line " & Str$(LineNbr) & ", Field " & Str$(I) & " = [" & Left$(Temp, Code) & "]"
  Call Display(X)
Next I
Extract = 1
End Function

Private Sub eMessage_Change()

End Sub

Private Sub Form_Load()
Dim Code As Long
Dim Version As Integer
Dim S1, S2, S3 As String
Dim Temp As String * 120
' attach FCE
Code = fceAttach(1, FCE_KEY_CODE)
' get FCE version number
Version = fceGetInteger(0, FCE_GET_VERSION)
S1 = "FTP Client Engine Version "
S2 = Hex$(Version)
S3 = Mid$(S2, 1, 1) + "." + Mid$(S2, 2, 1) + "." + Mid$(S2, 3, 1)
Call Display(S1 + S3)
' get registration string
Code = fceGetString(0, FCE_GET_REGISTRATION, Temp, 80&)
Call Display(Left$(Temp, Code))
End Sub

Private Sub mExit_Click()
Dim Code As Long
Code = fceRelease()
End
End Sub

Private Sub mList_Click()
Dim Code As Long
Dim Server As String
Dim User As String
Dim Pass As String
Dim LineNbr As Integer
Dim Temp As String * 120
Const BUFFER_SIZE = 3000
Dim Buffer As String * BUFFER_SIZE

Server = "10.0.0.1"
User = "mike"
Pass = "mike"

Call Display("Server = " + Server)
Call Display("User = " + User)
Call Display("Pass = " + Pass)

Code = fceSetString(0, FCE_SET_LOG_FILE, "LIST32.LOG")

' [uncomment to use "Passive Mode"]
'''Code = fceSetInteger(0, FCE_SET_PASSIVE, 1)

' [uncomment to set connect timeout value to 5 seconds]
'''Code = fceSetInteger(0, FCE_SET_CONNECT_WAIT, 5000)

DoEvents

' connect to server
Code = fceConnect(0, Server, User, Pass)
If Code < 0 Then
  Call ShowError(Code)
  Exit Sub
End If
DoEvents
Call Display("Connected to " + Server)
Temp = Space$(120)
Code = fceGetServerDir(0, Temp, 120)
Call Display("ServerDir = " + Left$(Temp, Code))
' ask for full list
Buffer = Space$(BUFFER_SIZE)
Code = fceGetList(0, FCE_FULL_LIST, Buffer, BUFFER_SIZE)
If Code <= 0 Then
  Call ShowError(Code)
  Exit Sub
End If
' get each  line
For LineNbr = 1 To 1000
  Code = Extract(LineNbr, Buffer)
  If Code = 0 Then
    Exit For
  End If
Next LineNbr
' close
DoEvents
Code = fceClose(0)
End Sub

Private Sub ShowError(ByVal Code As Long)
Dim Length As Integer
Dim Temp As String * 128
Length = fceErrorText(0, Code, Temp, 128)
Call Display(Left$(Temp, Length))
End Sub

